/**
---------------------------------------
 Mode                      = Advanced
 Part Number               = CMT2300A
 Frequency                 = 510.000 MHz
 Xtal Frequency            = 26.0000 MHz
 Demodulation              = FSK
 AGC                       = On
 Data Rate                 = 100.0 kbps
 Deviation                 = 50.0 kHz
 Tx Xtal Tol.              = 10 ppm
 Rx Xtal Tol.              = 10 ppm
 TRx Matching Network Type = 20 dBm
 Tx Power                  = +20 dBm
 Gaussian BT               = NA
 Bandwidth                 = Auto-Select kHz
 CDR Type                  = Counting
 CDR DR Range              = NA
 AFC                       = On
 AFC Method                = Auto-Select
 Data Representation       = 0:F-low 1:F-high
 Rx Duty-Cycle             = Off
 Tx Duty-Cycle             = Off
 Sleep Timer               = Off
 Sleep Time                = NA
 Rx Timer                  = Off
 Rx Time T1                = NA
 Rx Time T2                = NA
 Rx Exit State             = STBY
 Tx Exit State             = STBY
 SLP Mode                  = Disable
 RSSI Valid Source         = PJD
 PJD Window                = 8 Jumps
 LFOSC Calibration         = On
 Xtal Stable Time          = 155 us
 RSSI Compare TH           = NA
 Data Mode                 = Packet
 Whitening                 = Disable
 Whiten Type               = NA
 Whiten Seed Type          = NA
 Whiten Seed               = NA
 Manchester                = Disable
 Manchester Type           = NA
 FEC                       = Disable
 FEC Type                  = NA
 Tx Prefix Type            = 0
 Tx Packet Number          = 1
 Tx Packet Gap             = 32
 Packet Type               = Fixed Length
 Node-Length Position      = NA
 Payload Bit Order         = Start from msb
 Preamble Rx Size          = 2
 Preamble Tx Size          = 8
 Preamble Value            = 170
 Preamble Unit             = 8-bit
 Sync Size                 = 2-byte
 Sync Value                = 11732
 Sync Tolerance            = None
 Sync Manchester           = Disable
 Node ID Size              = NA
 Node ID Value             = NA
 Node ID Mode              = None
 Node ID Err Mask          = Disable
 Node ID Free              = Disable
 Payload Length            = 32
 CRC Options               = None
 CRC Seed                  = NA
 CRC Range                 = NA
 CRC Swap                  = NA
 CRC Bit Invert            = NA
 CRC Bit Order             = NA
 Dout Mute                 = Off
 Dout Adjust Mode          = Disable
 Dout Adjust Percentage    = NA
 Collision Detect          = Off
 Collision Detect Offset   = NA
 RSSI Detect Mode          = Always
 RSSI Filter Setting       = No Filtering
 RF Performance            = High
 LBD Threshold             = 2.4 V
 RSSI Offset               = 0
 RSSI Offset Sign          = 0
*/
#ifndef __CMT2300_PARAMS510_100_0KBPS_H
#define __CMT2300_PARAMS510_100_0KBPS_H

/* [CMT Bank] */
const uint8_t g_cmt2300CmtBank510_100_0kbps[CMT2300_CMT_BANK_SIZE] = {
    0x00,
    0x66,
    0xEC,
    0x1C,
    0x70,
    0x80,
    0x14,
    0x08,
    0x11,
    0x03,
    0x02,
    0x00,
};

/* [System Bank] */
const uint8_t g_cmt2300SystemBank510_100_0kbps[CMT2300_SYSTEM_BANK_SIZE] = {
    0xAE,
    0xE0,
    0x35,
    0x00,
    0x00,
    0xF4,
    0x10,
    0xE2,
    0x42,
    0x20,
    0x00,
    0x81,
};

/* [Frequency Bank] */
const uint8_t g_cmt2300FrequencyBank510_100_0kbps[CMT2300_FREQUENCY_BANK_SIZE] = {
    0x4E,
    0x8C,
    0x14,
    0x98,
    0x4E,
    0x76,
    0x62,
    0x17,
};

/* [Data Rate Bank] */
const uint8_t g_cmt2300DataRateBank510_100_0kbps[CMT2300_DATA_RATE_BANK_SIZE] = {
    0x3F,
    0xF0,
    0x63,
    0x10,
    0x63,
    0x12,
    0x0F,
    0x06,
    0x9F,
    0x6C,
    0x29,
    0x29,
    0xC0,
    0x04,
    0x01,
    0x53,
    0x20,
    0x00,
    0xB4,
    0x00,
    0x00,
    0x01,
    0x00,
    0x00,
};

/* [Baseband Bank] */
const uint8_t g_cmt2300BasebandBank510_100_0kbps[CMT2300_BASEBAND_BANK_SIZE] = {
    0x12,
    0x08,
    0x00,
    0xAA,
    0x02,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0xD4,
    0x2D,
    0x00,
    0x1F,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x60,
    0xFF,
    0x00,
    0x00,
    0x1F,
    0x10,
};

/* [Tx Bank] */
const uint8_t g_cmt2300TxBank510_100_0kbps[CMT2300_TX_BANK_SIZE] = {
    0x50,
    0x81,
    0x1F,
    0x00,
    0x00,
    0x30,
    0x00,
    0x10,
    0x02,
    0x7F,
    0x7F,
};

#endif
